<?php
/*
Plugin Name: Twitter Widget
Plugin URI: http://seanys.com/2007/10/12/twitter-wordpress-widget/
Description: Adds a sidebar widget to display Twitter updates (uses the Javascript <a href="http://twitter.com/badges/which_badge">Twitter 'badge'</a>)
Version: 1.0.3
Author: Sean Spalding
Author URI: http://seanys.com/
License: GPL

This software comes without any warranty, express or otherwise, and if it
breaks your blog or results in your cat being shaved, it's not my fault.

*/

function twitter_load_widgets() {
	register_widget('twitter_widget');
}

class Twitter_Widget extends WP_Widget {

function Twitter_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'Twitter_Widget', 'description' => __('Twitter Widget') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 300, 'height' => 200, 'id_base' => 'twitter-widget' );

		/* Create the widget. */
		$this->WP_Widget( 'twitter-widget', __('Twitter Widget'), $widget_ops, $control_ops );
	}


	function widget($args) {

		// "$args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys." - These are set up by the theme
		extract($args);

		// These are our own options
		$instance = get_option('widget');
		$account = $instance['account'];  // Your Twitter account name
		$title = $instance['title'];  // Title in sidebar for widget
		$show = $instance['show'];  // # of Updates to show

        // Output
		echo $before_widget ;

		// start
		echo '<div id="twitter_div">'
              .$before_title.$title.$after_title;
		echo '<ul id="twitter_update_list">';
		
		$twitter_json_url = 'http://api.twitter.com/1/statuses/user_timeline.json?screen_name='.$account.'&amp;include_rts=true&amp;count='.$show;
		$response = wp_remote_get( $twitter_json_url );
		$tweets = json_decode( wp_remote_retrieve_body( $response ), true );	
		
		
		function time_since( $original, $do_more = 0 ) {
		// array of time period chunks
		$chunks = array(
			array(60 * 60 * 24 * 365 , 'year'),
			array(60 * 60 * 24 * 30 , 'month'),
			array(60 * 60 * 24 * 7, 'week'),
			array(60 * 60 * 24 , 'day'),
			array(60 * 60 , 'hour'),
			array(60 , 'minute'),
		);

		$today = time();
		$since = $today - $original;

		for ($i = 0, $j = count($chunks); $i < $j; $i++) {
			$seconds = $chunks[$i][0];
			$name = $chunks[$i][1];

			if (($count = floor($since / $seconds)) != 0)
				break;
		}

		$print = ($count == 1) ? '1 '.$name : "$count {$name}s";

		if ($i + 1 < $j) {
			$seconds2 = $chunks[$i + 1][0];
			$name2 = $chunks[$i + 1][1];

			// add second item if it's greater than 0
			if ( (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) && $do_more )
				$print .= ($count2 == 1) ? ', 1 '.$name2 : ", $count2 {$name2}s";
		}
		return $print;
	}


		$tw_counter = 0;
		foreach( (array) $tweets as $tweet ) {
			if ( $tw_counter <= $show ) {

			if ( empty( $tweet['text'] ) )
				continue;
		
		if ( isset( $tweet['id_str'] ) )
			$tweet_id = urlencode( $tweet['id_str'] );
		else
			$tweet_id = urlencode( $tweet['id'] );
			
		$tweet['text'] = esc_html( $tweet['text'] ); // escape here so that Twitter handles in Tweets don't get mangled
		$tweet['text'] = make_clickable( $tweet['text'] ); 

			
		
		?>
		
		<li>
				<?php echo $tweet['text'] ?>
				<a href="<?php echo esc_url( "http://twitter.com/{$account}/statuses/{$tweet_id}" ); ?>" class="timesince"><?php echo esc_html( str_replace( ' ', '&nbsp;', time_since( strtotime( $tweet['created_at'] ) ) ) ); ?>&nbsp;ago</a>
		</li>
		<?php
		$tw_counter = $tw_counter + 1;
		}
	}
		
		
		echo '</ul></div>';
		
		// echo widget closing tag
		echo $after_widget;
	}



	// Settings form
	function update( $new_instance, $old_instance ) {
	$instance['account'] = $new_instance['account'];
	$instance['title'] = $new_instance['title'];
	$instance['show'] = $new_instance['show'];
	return $instance;
	}
		
		function form( $instance ) {
		
		// Get options
		$instance = get_option('widget');
		
		// options exist? if not set defaults
		if ( !is_array($instance) )
			$instance = array('account'=>'wordpress', 'title'=>'Twitter Updates', 'show'=>'5');

        // form posted?
		if (isset($_POST['Twitter-submit'])) {
		if ( $_POST['Twitter-submit'] ) {

			// Remember to sanitize and format use input appropriately.
			$instance['account'] = strip_tags(stripslashes($_POST['Twitter-account']));
			$instance['title'] = strip_tags(stripslashes($_POST['Twitter-title']));
			$instance['show'] = strip_tags(stripslashes($_POST['Twitter-show']));
			update_option('widget', $instance);
		}
		}

		// Get options for form fields to show
		$account = htmlspecialchars($instance['account'], ENT_QUOTES);
		$title = htmlspecialchars($instance['title'], ENT_QUOTES);
		$show = htmlspecialchars($instance['show'], ENT_QUOTES);

		// The form fields
		echo '<p style="text-align:right;">
				<label for="Twitter-account">' . __('Account:') . '
				<input style="width: 200px;" id="Twitter-account" name="Twitter-account" type="text" value="'.$account.'" />
				</label></p>';
		echo '<p style="text-align:right;">
				<label for="Twitter-title">' . __('Title:') . '
				<input style="width: 200px;" id="Twitter-title" name="Twitter-title" type="text" value="'.$title.'" />
				</label></p>';
		echo '<p style="text-align:right;">
				<label for="Twitter-show">' . __('Show:') . '
				<input style="width: 200px;" id="Twitter-show" name="Twitter-show" type="text" value="'.$show.'" />
				</label></p>';
		echo '<input type="hidden" id="Twitter-submit" name="Twitter-submit" value="1" />';
	}
}
	
function twitter_widget_script() {
		if ( ! wp_script_is( 'twitter-widgets', 'registered' ) ) {
			if ( is_ssl() )
				$twitter_widget_js = 'https://platform.twitter.com/widgets.js';
			else
				$twitter_widget_js = 'http://platform.twitter.com/widgets.js';
			wp_register_script( 'twitter-widgets', $twitter_widget_js,  array(), '20111117', true );
			wp_print_scripts( 'twitter-widgets' );
		}
	}


// Run code and init
add_action('widgets_init', 'twitter_load_widgets');

add_action('wp_head', 'twitter_widget_script');

?>
